Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/surf_landice_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/surf_landice_mod.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/surf_landice_mod.F90	(revision 3851)
@@ -25,5 +25,5 @@
 
     USE dimphy
-    USE surface_data,     ONLY : type_ocean, calice, calsno, ok_snow
+    USE surface_data,     ONLY : type_ocean, calice, calsno, landice_opt, n_dtis
     USE fonte_neige_mod,  ONLY : fonte_neige, run_off_lic
     USE cpl_mod,          ONLY : cpl_send_landice_fields
@@ -36,4 +36,9 @@
     USE surf_sisvat_mod,  ONLY : surf_sisvat
 #endif
+
+#ifdef CPP_INLANDSIS
+    USE surf_inlandsis_mod,  ONLY : surf_inlandsis
+#endif
+
     USE indice_sol_mod
 
@@ -86,6 +91,6 @@
 !    REAL, DIMENSION(klon), INTENT(OUT)            :: alb1  ! new albedo in visible SW interval
 !    REAL, DIMENSION(klon), INTENT(OUT)            :: alb2  ! new albedo in near IR interval
-    REAL, DIMENSION(6), INTENT(IN)              ::SFRWL
-    REAL, DIMENSION(klon,nsw), INTENT(OUT)        ::alb_dir,alb_dif
+    REAL, DIMENSION(6), INTENT(IN)                :: SFRWL
+    REAL, DIMENSION(klon,nsw), INTENT(OUT)        :: alb_dir,alb_dif
 !albedo SB <<<
     REAL, DIMENSION(klon), INTENT(OUT)            :: evap, fluxsens, fluxlat
@@ -108,16 +113,18 @@
     REAL, DIMENSION(klon)    :: zfra, alb_neig
     REAL, DIMENSION(klon)    :: radsol
-    REAL, DIMENSION(klon)    :: u0, v0, u1_lay, v1_lay
-    INTEGER                  :: i,j
+    REAL, DIMENSION(klon)    :: u0, v0, u1_lay, v1_lay, ustar
+    INTEGER                  :: i,j,nt
 
     REAL, DIMENSION(klon)    :: emis_new                  !Emissivity
     REAL, DIMENSION(klon)    :: swdown,lwdown
     REAL, DIMENSION(klon)    :: precip_snow_adv, snow_adv !Snow Drift precip./advection
-    REAL, DIMENSION(klon)    :: bl_height, wind_velo      !height boundary layer, wind spd
+    REAL, DIMENSION(klon)    :: zsl_height, wind_velo      !surface layer height, wind spd
     REAL, DIMENSION(klon)    :: dens_air,  snow_cont_air  !air density; snow content air
     REAL, DIMENSION(klon)    :: alb_soil                  !albedo of underlying ice
     REAL, DIMENSION(klon)    :: pexner                    !Exner potential
     REAL                     :: pref
-    REAL, DIMENSION(klon,nsoilmx) :: tsoil0 !modfi
+    REAL, DIMENSION(klon,nsoilmx) :: tsoil0               !modif
+    REAL                          :: dtis                ! subtimestep
+    LOGICAL                       :: debut_is, lafin_is  ! debut and lafin for inlandsis
 
     CHARACTER (len = 20)                      :: modname = 'surf_landice'
@@ -139,7 +146,8 @@
   LOGICAL, SAVE :: firstcall = .TRUE.
   !$OMP THREADPRIVATE(firstcall)
-!FC
-
-
+
+
+!FC firtscall initializations
+!******************************************************************************************
   IF (firstcall) THEN
   alb_vis_sno_lic=0.77
@@ -149,7 +157,11 @@
   CALL getin_p('alb_nir_sno_lic',alb_nir_sno_lic)
            PRINT*, 'alb_nir_sno_lic',alb_nir_sno_lic
+  
+!  z0m=1.e-3
+!  z0h = z0m
   firstcall=.false.
   ENDIF
-!
+!******************************************************************************************
+
 ! Initialize output variables
     alb3(:) = 999999.
@@ -166,9 +178,16 @@
 
 !****************************************************************************************
-!   ok_snow = TRUE  : prepare and call SISVAT snow model
-!   ok_snow = FALSE : soil_model, calcul_flux, fonte_neige, ... 
-!
-!****************************************************************************************
-    IF (ok_snow) THEN
+!  landice_opt = 0 : soil_model, calcul_flux, fonte_neige, ...  
+!  landice_opt = 1  : prepare and call SISVAT snow model
+!  landice_opt = 2  : prepare and call INLANDSIS snow model
+!****************************************************************************************
+
+
+    IF (landice_opt .EQ. 1) THEN
+    
+!****************************************************************************************
+! CALL to SISVAT interface
+!****************************************************************************************
+
 #ifdef CPP_SISVAT
        ! Prepare for calling SISVAT
@@ -192,11 +211,8 @@
           pexner(i)        = (p1lay(i)/pref)**(RD/RCPD)
           dens_air(i)      = p1lay(i)/RD/temp_air(i)  ! dry air density
-          bl_height(i)     = pphi1(i)/RG              
+          zsl_height(i)     = pphi1(i)/RG              
        END DO
 
-!****************************************************************************************
-! CALL to SISVAT interface
-!
-!****************************************************************************************
+
        ! config: compute everything with SV but temperatures afterwards with soil/calculfluxs
        DO i = 1, knon
@@ -209,5 +225,5 @@
             rmu0, swdown, lwdown, pexner, ps, p1lay, &
             precip_rain, precip_snow, precip_snow_adv, snow_adv, &
-            bl_height, wind_velo, temp_air, dens_air, spechum, tsurf, &
+            zsl_height, wind_velo, temp_air, dens_air, spechum, tsurf, &
             rugoro, snow_cont_air, alb_soil, slope, cloudf, &
             radsol, qsol, tsoil0, snow, snowhgt, qsnow, to_ice,sissnow, agesno, &
@@ -232,8 +248,87 @@
             flux_u1, flux_v1)
 #else
-       abort_message='Pb de coherence: ok_snow = .true. mais CPP_SISVAT = .false.'
+       abort_message='Pb de coherence: landice_opt = 1 mais CPP_SISVAT = .false.'
        CALL abort_physic(modname,abort_message,1)
 #endif
-    ELSE ! ok_snow=FALSE
+
+!****************************************************************************************
+! CALL to INLANDSIS interface
+!****************************************************************************************
+
+    ELSE IF (landice_opt .EQ. 2) THEN
+#ifdef CPP_INLANDSIS
+
+        debut_is=debut
+        lafin_is=.false.
+        ! Suppose zero surface speed
+        u0(:)            = 0.0
+        v0(:)            = 0.0
+
+
+        CALL calcul_flux_wind(knon, dtime, &
+         u0, v0, u1, v1, gustiness, cdragm, &
+         AcoefU, AcoefV, BcoefU, BcoefV, &
+         p1lay, temp_air, &
+         flux_u1, flux_v1)
+
+       
+       ! Set constants and compute some input for SISVAT
+       ! = 1000 hPa
+       ! and calculate incoming flux for SW and LW interval: swdown, lwdown
+       swdown(:)        = 0.0
+       lwdown(:)        = 0.0
+       snow_adv(:)      = 0.  ! no snow blown in for now
+       snow_cont_air(:) = 0.       
+       alb_soil(:)      = 0.4 ! before albedo(:) but here it is the ice albedo that we have to set
+       ustar(:)         = 0.
+       pref             = 100000.       
+       DO i = 1, knon
+          swdown(i)        = swnet(i)/(1-albedo(i))
+          lwdown(i)        = lwdownm(i)
+          wind_velo(i)     = u1(i)**2 + v1(i)**2
+          wind_velo(i)     = wind_velo(i)**0.5
+          pexner(i)        = (p1lay(i)/pref)**(RD/RCPD)
+          dens_air(i)      = p1lay(i)/RD/temp_air(i)  ! dry air density
+          zsl_height(i)    = pphi1(i)/RG      
+          tsoil0(i,:)      = tsoil(i,:)  
+          ustar(i)= (cdragm(i)*(wind_velo(i)**2))**0.5   
+       END DO
+       
+
+       ! Subtimestepping
+       
+        dtis=dtime/n_dtis
+
+        DO nt=1,n_dtis
+
+          IF (lafin .and. nt.eq.n_dtis) THEN
+            lafin_is=.true.
+          END IF
+
+        !PRINT*,'RENTRE DANS INLANDSIS','itime',itime,'dtime',dtime,'dtis',dtis
+        CALL surf_inlandsis(knon, rlon, rlat, knindex, itime, dtis, debut_is, lafin_is, &
+            rmu0, swdown, lwdown, albedo, pexner, ps, p1lay, &
+            precip_rain, precip_snow, precip_snow_adv, snow_adv, &
+            zsl_height, wind_velo, ustar, temp_air, dens_air, spechum, tsurf, &
+            rugoro, snow_cont_air, alb_soil, slope, cloudf, &
+            radsol, qsol, tsoil0, snow, zfra, snowhgt, qsnow, to_ice,sissnow, agesno, &
+            AcoefH, AcoefQ, BcoefH, BcoefQ, cdragm, cdragh, &
+            run_off_lic, evap, fluxsens, fluxlat, dflux_s, dflux_l, &        
+            tsurf_new, alb1, alb2, alb3, &
+            emis_new, z0m, z0h, qsurf)      
+
+         debut_is=.false.
+
+        END DO
+
+
+#else
+       abort_message='Pb de coherence: landice_opt = 2 mais CPP_INLANDSIS = .false.'
+       CALL abort_physic(modname,abort_message,1)
+#endif
+
+
+
+    ELSE 
 
 !****************************************************************************************
@@ -241,4 +336,10 @@
 ! 
 !****************************************************************************************
+
+    ! EV: use calbeta
+    CALL calbeta(dtime, is_lic, knon, snow, qsol, beta, cal, dif_grnd)
+
+
+    ! use soil model and recalculate properly cal
     IF (soil_model) THEN 
        CALL soil(dtime, is_lic, knon, snow, tsurf, tsoil, soilcap, soilflux)
@@ -255,6 +356,6 @@
 !
 !****************************************************************************************
-    beta(:) = 1.0
-    dif_grnd(:) = 0.0
+!    beta(:) = 1.0
+!    dif_grnd(:) = 0.0
 
 ! Suppose zero surface speed
@@ -281,5 +382,5 @@
 !    
 !****************************************************************************************
-    CALL fonte_neige( knon, is_lic, knindex, dtime, &
+    CALL fonte_neige(knon, is_lic, knindex, dtime, &
          tsurf, precip_rain, precip_snow, &
          snow, qsol, tsurf_new, evap)
@@ -291,4 +392,5 @@
 !****************************************************************************************
     CALL albsno(klon,knon,dtime,agesno(:),alb_neig(:), precip_snow(:))  
+
     WHERE (snow(1 : knon) .LT. 0.0001) agesno(1 : knon) = 0.
     zfra(1:knon) = MAX(0.0,MIN(1.0,snow(1:knon)/(snow(1:knon)+10.0)))
@@ -303,5 +405,5 @@
 !IM: KstaTER0.77 & LMD_ARMIP6    
 
-! Attantion: alb1 and alb2 are the same!
+! Attantion: alb1 and alb2 are not the same!
     alb1(1:knon)  = alb_vis_sno_lic
     alb2(1:knon)  = alb_nir_sno_lic
@@ -316,5 +418,10 @@
     z0m = SQRT(z0m**2+rugoro**2)
 
-    END IF ! ok_snow
+
+
+
+    
+
+    END IF ! landice_opt
 
 
@@ -333,12 +440,13 @@
   
 !****************************************************************************************
-       snow_o=0.
-       zfra_o = 0.
-       DO j = 1, knon
-           i = knindex(j)
-           snow_o(i) = snow(j) 
-           zfra_o(i) = zfra(j)
-       ENDDO
-
+! Etienne: comment these lines because of duplication just below
+!       snow_o=0.
+!       zfra_o = 0.
+!       DO j = 1, knon
+!           i = knindex(j)
+!           snow_o(i) = snow(j) 
+!           zfra_o(i) = zfra(j)
+!       ENDDO
+!
 !****************************************************************************************
        snow_o=0.
Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/surf_ocean_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/surf_ocean_mod.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/surf_ocean_mod.F90	(revision 3851)
@@ -20,7 +20,9 @@
        z0m, z0h, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, & 
        tsurf_new, dflux_s, dflux_l, lmt_bils, &
-       flux_u1, flux_v1)
+       flux_u1, flux_v1, delta_sst, delta_sal, ds_ns, dt_ns, dter, dser, tkt, tks, &
+       taur, sss)
 
     use albedo, only: alboc, alboc_cd
+    use bulk_flux_m, only: bulk_flux
     USE dimphy, ONLY: klon, zmasq
     USE surface_data, ONLY     : type_ocean
@@ -30,4 +32,5 @@
     USE indice_sol_mod, ONLY : nbsrf, is_oce
     USE limit_read_mod
+    use config_ocean_skin_m, only: activate_ocean_skin
     !
     ! This subroutine will make a call to ocean_XXX_noice according to the ocean mode (force, 
@@ -50,8 +53,8 @@
     REAL, DIMENSION(klon), INTENT(IN)        :: lwnet  ! net longwave radiation at surface  
     REAL, DIMENSION(klon), INTENT(IN)        :: alb1   ! albedo in visible SW interval
-    REAL, DIMENSION(klon), INTENT(IN)        :: windsp
+    REAL, DIMENSION(klon), INTENT(IN)        :: windsp ! wind at 10 m, in m s-1
     REAL, DIMENSION(klon), INTENT(IN)        :: rmu0  
     REAL, DIMENSION(klon), INTENT(IN)        :: fder
-    REAL, DIMENSION(klon), INTENT(IN)        :: tsurf_in
+    REAL, INTENT(IN):: tsurf_in(klon) ! defined only for subscripts 1:knon
     REAL, DIMENSION(klon), INTENT(IN)        :: p1lay,z1lay ! pression (Pa) et altitude (m) du premier niveau
     REAL, DIMENSION(klon), INTENT(IN)        :: cdragh
@@ -73,6 +76,24 @@
     REAL, DIMENSION(klon), INTENT(inOUT):: z0h
 
+    REAL, intent(inout):: delta_sst(:) ! (knon)
+    ! Ocean-air interface temperature minus bulk SST, in K. Defined
+    ! only if activate_ocean_skin >= 1.
+
+    real, intent(inout):: delta_sal(:) ! (knon)
+    ! Ocean-air interface salinity minus bulk salinity, in ppt. Defined
+    ! only if activate_ocean_skin >= 1.
+
+    REAL, intent(inout):: ds_ns(:) ! (knon)
+    ! "delta salinity near surface". Salinity variation in the
+    ! near-surface turbulent layer. That is subskin salinity minus
+    ! foundation salinity. In ppt.
+
+    REAL, intent(inout):: dt_ns(:) ! (knon)
+    ! "delta temperature near surface". Temperature variation in the
+    ! near-surface turbulent layer. That is subskin temperature
+    ! minus foundation temperature. (Can be negative.) In K.
+
     ! Output variables
-    !******************************************************************************
+    !**************************************************************************
     REAL, DIMENSION(klon), INTENT(OUT)       :: z0m
     !albedo SB >>>
@@ -83,11 +104,35 @@
     !albedo SB <<<     
     REAL, DIMENSION(klon), INTENT(OUT)       :: evap, fluxsens, fluxlat
-    REAL, DIMENSION(klon), INTENT(OUT)       :: tsurf_new
+    REAL, INTENT(OUT):: tsurf_new(klon) ! sea surface temperature, in K
     REAL, DIMENSION(klon), INTENT(OUT)       :: dflux_s, dflux_l      
     REAL, DIMENSION(klon), INTENT(OUT)       :: lmt_bils
     REAL, DIMENSION(klon), INTENT(OUT)       :: flux_u1, flux_v1
 
+    REAL, intent(out):: dter(:) ! (knon)
+    ! Temperature variation in the diffusive microlayer, that is
+    ! ocean-air interface temperature minus subskin temperature. In
+    ! K.
+
+    REAL, intent(out):: dser(:) ! (knon)
+    ! Salinity variation in the diffusive microlayer, that is
+    ! ocean-air interface salinity minus subskin salinity. In ppt.
+
+    REAL, intent(out):: tkt(:) ! (knon)
+    ! épaisseur (m) de la couche de diffusion thermique (microlayer)
+    ! cool skin thickness
+
+    REAL, intent(out):: tks(:) ! (knon)
+    ! épaisseur (m) de la couche de diffusion de masse (microlayer)
+
+    REAL, intent(out):: taur(:) ! (knon)
+    ! momentum flux due to rain, in Pa
+
+    real, intent(out):: sss(:) ! (klon)
+    ! Bulk salinity of the surface layer of the ocean, in ppt. (Only
+    ! defined for subscripts 1:knon, but we have to declare it with
+    ! size klon because of the coupling machinery.)
+
     ! Local variables
-    !******************************************************************************
+    !*************************************************************************
     INTEGER               :: i, k
     REAL                  :: tmp
@@ -97,7 +142,11 @@
     REAL, DIMENSION(klon) :: cdragq ! Cdrag pour l'evaporation
     CHARACTER(len=20),PARAMETER :: modname="surf_ocean"
-
-    ! End definition
-    !******************************************************************************
+    real rhoa(knon) ! density of moist air  (kg / m3)
+    REAL sens_prec_liq(knon)
+
+    REAL t_int(knon) ! ocean-air interface temperature, in K
+    real s_int(knon) ! ocean-air interface salinity, in ppt
+
+    !**************************************************************************
 
 
@@ -126,5 +175,5 @@
     ENDIF
 
-
+    rhoa = PS(:KNON) / (Rd * temp_air(:knon) * (1. + retv * spechum(:knon)))
     !******************************************************************************
     ! Switch according to type of ocean (couple, slab or forced)
@@ -139,8 +188,9 @@
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
-            ps, u1, v1, gustiness, &
+            ps, u1, v1, gustiness, tsurf_in, &
             radsol, snow, agesno, &
             qsurf, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
-            tsurf_new, dflux_s, dflux_l)
+            tsurf_new, dflux_s, dflux_l, sens_prec_liq, sss, delta_sal, rhoa, &
+            delta_sst)
 
     CASE('slab')
@@ -162,8 +212,8 @@
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
-            ps, u1, v1, gustiness, &
+            ps, u1, v1, gustiness, tsurf_in, &
             radsol, snow, agesno, &
             qsurf, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
-            tsurf_new, dflux_s, dflux_l)
+            tsurf_new, dflux_s, dflux_l, sens_prec_liq, rhoa)
     END SELECT
 
@@ -268,8 +318,22 @@
        CALL abort_physic(modname,'version non prevue',1)
     ENDIF
-    !
-    !******************************************************************************
+
+    if (activate_ocean_skin >= 1) then
+       if (type_ocean /= 'couple') sss(:knon) = 35.
+       call bulk_flux(tkt, tks, taur, dter, dser, t_int, s_int, ds_ns, dt_ns, &
+            u = windsp(:knon), t_ocean_1 = tsurf_new(:knon), s1 = sss(:knon), &
+            rain = precip_rain(:knon) + precip_snow(:knon), &
+            hf = - fluxsens(:knon), hlb = - fluxlat(:knon), &
+            rnl = - lwnet(:knon), &
+            tau = sqrt(flux_u1(:knon)**2 + flux_v1(:knon)**2), rhoa = rhoa, &
+            xlv = [(rlvtt, i = 1, knon)], rf = - sens_prec_liq, dtime = dtime, &
+            rns = swnet(:knon))
+       delta_sst = t_int - tsurf_new(:knon)
+       delta_sal = s_int - sss(:knon)
+       if (activate_ocean_skin >= 2) tsurf_new(:knon) = t_int
+    end if
+    
   END SUBROUTINE surf_ocean
-  !******************************************************************************
+  !****************************************************************************
   !
 END MODULE surf_ocean_mod
Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/surf_seaice_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/surf_seaice_mod.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/surf_seaice_mod.F90	(revision 3851)
@@ -37,4 +37,7 @@
     INCLUDE "dimsoil.h"
     INCLUDE "clesphys.h"
+
+    INCLUDE "YOMCST.h"
+    ! for rd and retv
 
 ! Input arguments
@@ -87,5 +90,7 @@
     REAL, DIMENSION(klon) :: alb1_new,alb2_new
 !albedo SB <<<
-!
+
+    real rhoa(knon) ! density of moist air  (kg / m3)
+
 ! End definitions
 !****************************************************************************************
@@ -98,4 +103,6 @@
     radsol(:) = 0.0
     radsol(1:knon) = swnet(1:knon) + lwnet(1:knon)
+
+    rhoa = PS(:KNON) / (Rd * temp_air(:knon) * (1. + retv * spechum(:knon)))
 
 !****************************************************************************************
@@ -116,5 +123,5 @@
             radsol, snow, qsurf, &
             alb1_new, alb2_new, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
-            tsurf_new, dflux_s, dflux_l)
+            tsurf_new, dflux_s, dflux_l, rhoa)
        
     ELSE IF (type_ocean == 'slab'.AND.version_ocean=='sicINT') THEN
@@ -138,5 +145,5 @@
             radsol, snow, qsol, agesno, tsoil, &
             qsurf, alb1_new, alb2_new, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
-            tsurf_new, dflux_s, dflux_l)
+            tsurf_new, dflux_s, dflux_l, rhoa)
 
     END IF
Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/surface_data.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/surface_data.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/surface_data.F90	(revision 3851)
@@ -15,7 +15,4 @@
   !$OMP THREADPRIVATE(type_veget)
 
-  LOGICAL, SAVE          :: ok_snow       ! true for coupling to snow model SISVAT
-  !$OMP THREADPRIVATE(ok_snow)
-
   CHARACTER(len=6), SAVE :: type_ocean    ! force/slab/couple
   !$OMP THREADPRIVATE(type_ocean)
@@ -30,3 +27,22 @@
   !$OMP THREADPRIVATE(t_coupl)
 
+  ! FOR INLANDSIS:
+  !===============
+
+   INTEGER, SAVE          :: landice_opt       ! 1 for coupling with SISVAT, 2 for coupling with INLANDSIS
+  !$OMP THREADPRIVATE(landice_opt)
+
+   INTEGER, SAVE          :: iflag_tsurf_inlandsis ! 0 SISVAT method, 1 LMDZ method
+  !$OMP THREADPRIVATE(iflag_tsurf_inlandsis)
+
+   INTEGER, SAVE          :: iflag_albzenith ! dependency of albedo to zenith angle
+  !$OMP THREADPRIVATE(iflag_albzenith)  
+
+   INTEGER, SAVE          :: n_dtis           ! number of subtimesteps for INLANDSIS
+  !$OMP THREADPRIVATE(n_dtis)
+
+  ! with or without snow module/ blowing snow, ascii outfile
+   LOGICAL, SAVE           :: SnoMod,BloMod,ok_outfor 
+  !$OMP THREADPRIVATE(SnoMod,BloMod,ok_outfor)    
+
 END MODULE surface_data
Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/yamada4.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/yamada4.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/yamada4.F90	(revision 3851)
@@ -6,5 +6,6 @@
   USE dimphy
   USE ioipsl_getin_p_mod, ONLY : getin_p
-
+  USE phys_local_var_mod, only: tke_dissip
+  
   IMPLICIT NONE
   include "iniprint.h"
@@ -56,8 +57,10 @@
   !             iflag_pbl=11 -> the model starts with NP from start files created by ce0l
   !                          -> the model can run with longer time-steps.
-  !             2016/11/30 (EV etienne.vignon@univ-grenoble-alpes.fr)
+  !             2016/11/30 (EV etienne.vignon@lmd.ipsl.fr)
   !               On met tke (=q2/2) en entr??e plut??t que q2
   !               On corrige l'update de la tke
-  !
+  !             2020/10/01 (EV)
+  !               On ajoute la dissipation de la TKE en diagnostique de sortie
+  !                  
   ! Inpout/Output :
   !==============
@@ -121,5 +124,5 @@
   REAL,SAVE :: viscom,viscoh
   !$OMP THREADPRIVATE( hboville,viscom,viscoh)
-  INTEGER ig, k
+  INTEGER ig, jg, k
   REAL ri, zrif, zalpha, zsm, zsn
   REAL rif(klon, klev+1), sm(klon, klev+1), alpha(klon, klev)
@@ -186,4 +189,5 @@
        viscom=1.46E-5
        viscoh=2.06E-5
+       !lmixmin=1.0E-3
        lmixmin=0.
        yamada4_num=5
@@ -416,4 +420,9 @@
   ELSE IF (iflag_pbl>=10) THEN
 
+    shear(:,:)=0.
+    buoy(:,:)=0.
+    dissip(:,:)=0.
+    km(:,:)=0.
+        
     IF (yamada4_num>=1) THEN
  
@@ -424,8 +433,9 @@
       shear(ig,k)=km(ig, k)*m2(ig, k)
       buoy(ig,k)=km(ig, k)*m2(ig, k)*(-1.*rif(ig,k))
-      dissip(ig,k)=((sqrt(q2(ig,k)))**3)/(b1*l(ig,k))
+!      dissip(ig,k)=min(max(((sqrt(q2(ig,k)))**3)/(b1*l(ig,k)),1.E-12),1.E4)
+      dissip(ig,k)=((sqrt(q2(ig,k)))**3)/(b1*l(ig,k)) 
      ENDDO
     ENDDO
-
+    
     IF (yamada4_num==1) THEN ! Schema du MAR tel quel
        DO k = 2, klev - 1
@@ -478,4 +488,9 @@
         ENDDO
        ENDDO
+       
+      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      !! Attention, yamada4_num=5 est inexacte car néglige les termes de flottabilité
+      !! en conditions instables
+      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     ELSE IF (yamada4_num==5) THEN ! version modifiee avec integration exacte pour la dissipation
        DO k = 2, klev - 1
@@ -507,13 +522,23 @@
        DO k = 2, klev - 1
          DO ig=1,ngrid
+         !tkeprov=q2(ig,k)/ydeux
+         !tkeprov=tkeprov+max(buoy(ig,k)+shear(ig,k),0.)*dt
+         !disseff=dissip(ig,k)-min(0.,buoy(ig,k)+shear(ig,k)) 
+         !tkeexp=exp(-dt*disseff/tkeprov)
+         !tkeprov= tkeprov*tkeexp
+         !q2(ig,k)=tkeprov*ydeux
+         ! En cas stable, on traite la flotabilite comme la
+         ! dissipation, en supposant que dissipeff/TKE est constant.
+         ! Puis on prend la solution exacte
+         ! 
+         ! With drag and dissipation from high vegetation (EV & FC, 05/10/2020)
+         winds(ig,k)=sqrt(u(ig,k)**2+v(ig,k)**2)
          tkeprov=q2(ig,k)/ydeux
-         tkeprov=tkeprov+max(buoy(ig,k)+shear(ig,k),0.)*dt
-         disseff=dissip(ig,k)-min(0.,buoy(ig,k)+shear(ig,k))
+         tkeprov=tkeprov+max(buoy(ig,k)+shear(ig,k)+drgpro(ig,k)*(winds(ig,k))**3,0.)*dt
+         disseff=dissip(ig,k)-min(0.,buoy(ig,k)+shear(ig,k)+drgpro(ig,k)*(winds(ig,k))**3) + drgpro(ig,k)*tkeprov
          tkeexp=exp(-dt*disseff/tkeprov)
          tkeprov= tkeprov*tkeexp
          q2(ig,k)=tkeprov*ydeux
-         ! En cas stable, on traite la flotabilite comme la
-         ! dissipation, en supposant que buoy/q2^3 est constant.
-         ! Puis on prend la solution exacte
+         
         ENDDO
        ENDDO
@@ -725,4 +750,17 @@
 
 !============================================================================
+! Diagnostique de la dissipation
+!============================================================================
+
+! Diagnostics
+ tke_dissip(1:ngrid,:,nsrf)=0.
+! DO k=2,klev
+!    DO ig=1,ngrid
+!       jg=ni(ig)
+!       tke_dissip(jg,k,nsrf)=dissip(ig,k)
+!    ENDDO
+! ENDDO
+ 
+!=============================================================================
 
   RETURN
@@ -1017,5 +1055,5 @@
 !=====================================================================
 
-
+  l1(1:ngrid,:)=0.
   IF (iflag_pbl==8 .OR. iflag_pbl==10) THEN
 
@@ -1135,5 +1173,5 @@
 
 
- DO k=2,klev
+ DO k=1,klev+1
     DO ig=1,ngrid
        lmix(ig,k)=MAX(MAX(l1(ig,k), l2(ig,k)),lmixmin)
